image: openjdk:8-jdk-slim

variables:
  DOCKER_DRIVER: overlay2

before_script:
  - export GRADLE_USER_HOME=`pwd`/.gradle
  - export M2_HOME=`pwd`/.m2

cache:
  paths:
    - .gradle

stages:
  - build
  - deploy

# Build and cache build results and publication
build:
  stage: build
  script:
    - ./gradlew -i --stacktrace downloadLicenses assemble
  artifacts:
    paths:
      - build
    expire_in: 1 hour
  except:
    - master

# Build final result and deploy
pages:
  stage: deploy
  dependencies:
    - build
  environment:
    name: Gradle Plugin Portal
    url: https://plugins.gradle.org/plugin/org.proticity.gradle.idea-plus
  script:
    - ./gradlew -i --stacktrace -Dgradle.publish.key=${GRADLE_PLUGIN_PUBLISH_KEY} -Dgradle.publish.secret=${GRADLE_PLUGIN_PUBLISH_SECRET} assemble publishPlugins
    - mkdir public
    - mv build/docs/groovydoc public/apidocs
  artifacts:
    paths:
      - build/libs
      - build/publications
      - public
  only:
    changes:
      - gradle.properties
    refs:
      - master
